/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest{}

// AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest struct for AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest
type AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest struct {
	Service *string                          `json:"service,omitempty"`
	Data    *MicrosoftAdsStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest instantiates a new AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest() *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest {
	this := AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest{}
	var service string = "microsoft_ads_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest {
	this := AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest{}
	var service string = "microsoft_ads_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) GetData() MicrosoftAdsStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret MicrosoftAdsStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) GetDataOk() (*MicrosoftAdsStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given MicrosoftAdsStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) SetData(v MicrosoftAdsStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest struct {
	value *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) Get() *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) Set(val *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest(val *AppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) *NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerMicrosoftAdsStaticMicrosoftAdsStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
